/* urllog.cmd - takes output from checkurl.log - list
of bad urls and extracts link text from bookmark file */

/* jt didit 7 Mar 2001 - Julian Thomas - jt@epix.net
   revised 23 Mar 2001 by Francesco Cipriani <fc76@softhome.net>
   author of checkurl.  Changed to work with 162 logfile format, but fix  */

prog='urllog.cmd'
infile='checkurl.log'
outfile='badurls'

parse arg bmarkfile ifil .

if bmarkfile='' then do
   say 'usage is' prog ' bookmark filespec [infile]'
   say 'reads' infile ' - checkurl 1.6.2 logfile'
   say 'infile is checkurl.log filespec - default is' infile
   say 'output is to' outfile
   exit
   end

if ifil<>'' then infile=ifil

call sysfiledelete(outfile)


say infile

do forever while lines(infile)>0
do while queued()>0
   pull junk
   end
lin=linein(infile)
if lin='' then iterate
/* if left(lin,4)<>'Url:' then iterate */
url=word(lin,1)
if url='' then    say 'blank url'
if url='' then iterate
/* lin=linein(infile) */
if word(lin,2)<>"Error:" then iterate
err=subword(lin,3)



'@grep "'url'"' bmarkfile '| RXQUEUE'

if queued()=0 then say  '** no bmark for' url

if queued()=0 then iterate

do while queued()>0
   parse pull lin2
   if pos('HREF',lin2)=0 then iterate
   txt=cleanup(lin2)
   outlin=txt '==' url '==>' err
   call lineout outfile,outlin
   call lineout outfile,''
   end
end /* do forever */
call lineout outfile
call lineout infile
exit

cleanup:
parse arg linx
z=pos('HREF=',linx)
if z=0 then return '???'
linx=substr(linx,z+6)
z=pos('>',linx)
linx=substr(linx,z+1)
z=pos('<',linx)
return left(linx,z-1)


